VERSION 5.00
Begin VB.Form MainFrm 
   Appearance      =   0  'Flat
   AutoRedraw      =   -1  'True
   BackColor       =   &H00FFFFFF&
   Caption         =   "MERVBot - Shell View"
   ClientHeight    =   5145
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   9375
   ClipControls    =   0   'False
   FillColor       =   &H00FFFFFF&
   BeginProperty Font 
      Name            =   "MS Serif"
      Size            =   9.75
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   Icon            =   "Main.frx":0000
   LinkTopic       =   "SSBilling"
   ScaleHeight     =   5145
   ScaleWidth      =   9375
   Begin VB.Timer Periodic 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   480
      Top             =   0
   End
   Begin VB.Timer SSL 
      Enabled         =   0   'False
      Interval        =   2000
      Left            =   0
      Top             =   0
   End
End
Attribute VB_Name = "MainFrm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Toggle As Boolean   'Use a 500ms timer as a 1 second timer also
Private Toggle2 As Byte     'Use a 1 second timer as a 20 second timer also

Private Sub Form_KeyPress(KeyAscii As Integer)
    If KeyAscii = 9 Then CycleFocus
End Sub

'Mainfrm.FORM

Private Sub Form_Resize()
    If MainFrm.WindowState = 1 Then
        MainFrm.Visible = False
        Exit Sub
    End If

    ResizeMsgs True
End Sub

Private Sub Form_Unload(Cancel As Integer)
    ShutDown
End Sub

'Timers

Private Sub SSL_Timer()
    ResendMessages
End Sub

Private Sub Periodic_Timer()
On Error GoTo FlyPaper

    Dim BotID As Integer, I As Integer, B As Byte

    For BotID = 1 To MAX_BOTS
        If BotList(BotID).SlotClosed = 1 Then
            'Position packets (KeepAlives)
            With BotList(BotID)
                If .Periodic = 1 Then
                    If .AttachedTo <> -1 Then
                        SendPosition BotID, .pList(.AttachedTo).X, 0, .pList(.AttachedTo).Y, 0, .pList(.AttachedTo).D, -1, NoProjectile, 0, 0
                        SendPosition BotID, .pList(.AttachedTo).X, 0, .pList(.AttachedTo).Y, 0, .pList(.AttachedTo).D, -1, Thor, 0, 0
                    Else
                        Do
                            .CenteredOn = .CenteredOn + 1
                            If .CenteredOn = 255 Then .CenteredOn = 0
                        Loop While .pList(.CenteredOn).SSName = ""
                        SendPosition BotID, .pList(.CenteredOn).X, 0, .pList(.CenteredOn).Y, 0, 0, -1, NoProjectile, 0, 0
                    End If

                    .KeepAliveCount = .KeepAliveCount + 1
                    If .KeepAliveCount >= 30 Then
                        SendSync BotID
                        .KeepAliveCount = 0
                    End If
                End If
            End With
        End If
    Next

    If Toggle Then
        Toggle = False
    Else
        Toggle = True
        Exit Sub
    End If

    Toggle2 = Toggle2 + 1

    SendQueue

    If Toggle2 >= 20 Then Toggle2 = 0

    For BotID = 1 To MAX_BOTS
        With BotList(BotID)
            If .SlotClosed = 1 Then
                'Make special non-reliable messages reliable
                If Toggle2 = 9 Then
                    'Resend 05-06 Sync packets
                    If .Got06 = 0 Then SendSync BotID
                End If
                If Toggle2 = 19 Then
                    'Reconnect
                    If .HasSession = 0 Then ConnectBot BotID

                    'Resend 05-06 Sync packets
                    If .Got06 = 0 Then SendSync BotID
                End If

                'Periodic prizes
                If .PrizeEnabled = 1 Then
                    .PrizeCounter = .PrizeCounter + 1
                    If .PrizeCounter >= .PrizeWait Then
                        .PrizeCounter = 0
                        If .PrizeNumber = 0 Then
                            PublicMessage BotID, "*shipreset", 0
                        Else
                            PublicMessage BotID, "*prize #" + CStr(.PrizeNumber), 0
                        End If
                    End If
                End If

                'Keep teams even
                If .EvenTeams > 0 Then
                    I = TeamUnevenCount(BotID)
                    If I > .EvenTeams Then
                        If .EvenCounter = 10 Then
                            EvenTeams BotID
                            PublicMessage BotID, "*arena Teams are now even.", 2
                        ElseIf .EvenCounter >= 15 Then
                            .EvenCounter = 0
                        ElseIf .EvenCounter = 0 Then
                            PublicMessage BotID, "*arena Teams are uneven. " + CStr(I \ 2) + " player(s) must switch", 1
                        End If
                        .EvenCounter = .EvenCounter + 1
                    Else
                        If .EvenCounter > 10 Then
                            .EvenCounter = 0
                        ElseIf .EvenCounter > 0 Then
                            PublicMessage BotID, "*arena Teams are now even.", 2
                            .EvenCounter = 0
                        End If
                    End If
                End If

                'Game timers
                If .Bot_Enabled = 1 Then
                    Select Case .Bot_Type
                        Case BOT_FLAVORS.ELIM_REF
                            Select Case .Bot_Status
                                Case GAME_STATUS.CHECK
                                    'Enough players, all on same freq, etc
                                    If CheckPlayerCount(BotID, 2, False) = True Then
                                        PublicMessage BotID, "*zone Next elimination match is starting. Type ?go " + .ArenaName + " to play", 0
                                        PublicMessage BotID, "*arena Vote: 1- any ship elim, 2- any ship race, 3- wb elim, 4- wb race, 5- jav elim, 6- jav race, 7- team elim, 8- golf", 2
                                        .TimerCounter = 0
                                        .Bot_Status = VOTE_GAME
                                    End If

                                Case GAME_STATUS.STARTED
                                    'Check for GAME OVER
                                    .TimerCounter = .TimerCounter + 1
                                    If .TimerCounter >= 20 Then
                                        .TimerCounter = 0
                                        FindHiders BotID, MAX_X \ 10
                                    End If
                                    If .GameType = ELIM_TYPE.Vanilla Or .GameType = ELIM_TYPE.WBElim Or .GameType = ELIM_TYPE.JavElim Or .GameType = ELIM_TYPE.GolfElim Then
                                        If TotalItems(BotID) = 1 Then
                                            PublicMessage BotID, "*arena GAME OVER. Winner: " + SharedList(BotID, 1), 103
                                            PublicMessage BotID, "*lock", 0
                                            TeamMessage BotID, "You may enter", 0
                                            BotList(BotID).LockShip = 0
                                            .Bot_Status = CHECK
                                            I = FindUser(BotID, SharedList(BotID, 1))
                                            UpdateRank .pList(I).SSName, True, .pList(I).Wins, .pList(I).Losses
                                        ElseIf TotalItems(BotID) = 0 Then
                                            PublicMessage BotID, "*arena GAME OVER. No winner", 103
                                            PublicMessage BotID, "*lock", 0
                                            TeamMessage BotID, "You may enter", 0
                                            BotList(BotID).LockShip = 0
                                            .Bot_Status = CHECK
                                        End If
                                    ElseIf .GameType = ELIM_TYPE.TeamElim Then
                                        Select Case CheckTeamElimVictory(BotID)
                                            Case 0
                                                PublicMessage BotID, "*arena GAME OVER. Winner: Team 0", 103
                                                PublicMessage BotID, "*lock", 0
                                                TeamMessage BotID, "You may enter", 0
                                                .Bot_Status = CHECK
                                                For B = 1 To TotalItems(BotID)
                                                    I = FindUser(BotID, SharedList(BotID, B))
                                                    UpdateRank .pList(I).SSName, True, .pList(I).Wins, .pList(I).Losses
                                                Next
                                            Case 1
                                                PublicMessage BotID, "*arena GAME OVER. Winner: Team 1", 103
                                                PublicMessage BotID, "*lock", 0
                                                TeamMessage BotID, "You may enter", 0
                                                .Bot_Status = CHECK
                                                For B = 1 To TotalItems(BotID)
                                                    I = FindUser(BotID, SharedList(BotID, B))
                                                    UpdateRank .pList(I).SSName, True, .pList(I).Wins, .pList(I).Losses
                                                Next
                                        End Select
                                    End If

                                Case GAME_STATUS.VOTE_GAME
                                    'Wait for votes on game-type
                                    .TimerCounter = .TimerCounter + 1
                                    If .TimerCounter >= 15 Then
                                        If CheckPlayerCount(BotID, 2, False) = True Then
                                            .MaxDeaths = GetMedianVote(BotID)
                                            Select Case .MaxDeaths
                                                Case ELIM_TYPE.Vanilla:  PublicMessage BotID, "*arena It is elim. Number of deaths? (1-10)", 2
                                                Case ELIM_TYPE.Race:     PublicMessage BotID, "*arena It is race. Number of kills? (1-10)", 2
                                                Case ELIM_TYPE.WBElim:   PublicMessage BotID, "*arena It is warbird elim. Number of deaths? (1-10)", 2
                                                Case ELIM_TYPE.WBRace:   PublicMessage BotID, "*arena It is warbird race. Number of kills? (1-10)", 2
                                                Case ELIM_TYPE.JavElim:  PublicMessage BotID, "*arena It is javelin elim. Number of deaths? (1-10)", 2
                                                Case ELIM_TYPE.JavRace:  PublicMessage BotID, "*arena It is javelin race. Number of kills? (1-10)", 2
                                                Case ELIM_TYPE.TeamElim: PublicMessage BotID, "*arena It is team elim. Number of deaths? (1-10)", 2
                                                Case ELIM_TYPE.GolfElim: PublicMessage BotID, "*arena It is golf elim. Maximum number of points? (1-10)", 2
                                            End Select
                                            .GameType = .MaxDeaths
                                            .TimerCounter = 0
                                            .Bot_Status = VOTE_DEATHS
                                        Else
                                            PublicMessage BotID, "*arena Not enough players. Elim will start when 2 players enter", 1
                                            .TimerCounter = 0
                                            .Bot_Status = CHECK
                                        End If
                                    End If

                                Case GAME_STATUS.VOTE_DEATHS
                                    'Wait for votes on deaths or wins
                                    .TimerCounter = .TimerCounter + 1
                                    If .TimerCounter >= 15 Then
                                        If CheckPlayerCount(BotID, 2, False) = True Then
                                            .MaxDeaths = GetMedianVote(BotID)
                                            Select Case .GameType
                                                Case ELIM_TYPE.Vanilla: PublicMessage BotID, "*arena Elimination to " + CStr(.MaxDeaths) + " death(s). Get ready; the game will start in 10 seconds", 2
                                                Case ELIM_TYPE.Race: PublicMessage BotID, "*arena Race to " + CStr(.MaxDeaths) + " kill(s). Get ready; the game will start in 10 seconds", 2
                                                Case ELIM_TYPE.WBElim: PublicMessage BotID, "*arena Warbird Elimination to " + CStr(.MaxDeaths) + " death(s). Get ready; the game will start in 10 seconds", 2
                                                Case ELIM_TYPE.WBRace: PublicMessage BotID, "*arena Warbird Race to " + CStr(.MaxDeaths) + " kill(s). Get ready; the game will start in 10 seconds", 2
                                                Case ELIM_TYPE.JavElim: PublicMessage BotID, "*arena Javelin Elimination to " + CStr(.MaxDeaths) + " death(s). Get ready; the game will start in 10 seconds", 2
                                                Case ELIM_TYPE.JavRace: PublicMessage BotID, "*arena Javelin Race to " + CStr(.MaxDeaths) + " kill(s). Get ready; the game will start in 10 seconds", 2
                                                Case ELIM_TYPE.TeamElim: PublicMessage BotID, "*arena Team Elimination to " + CStr(.MaxDeaths) + " death(s). Get ready; the game will start in 10 seconds", 2
                                                Case ELIM_TYPE.GolfElim: PublicMessage BotID, "*arena Golf Elimination up to " + CStr(.MaxDeaths) + " point(s). Get ready; the game will start in 10 seconds", 2
                                            End Select
                                            .TimerCounter = 0
                                            .Bot_Status = WAIT_AFTER_RESULTS
                                        Else
                                            PublicMessage BotID, "*arena Not enough players. Elim will start when 2 players enter", 1
                                            .TimerCounter = 0
                                            .Bot_Status = CHECK
                                        End If
                                    End If

                                Case GAME_STATUS.WAIT_AFTER_RESULTS
                                    'Wait for 10 seconds, then start the elim
                                    .TimerCounter = .TimerCounter + 1
                                    If .TimerCounter >= 10 Then
                                        If CheckPlayerCount(BotID, 2, False) = True Then
                                            AddGamePlayers BotID, False
                                            PublicMessage BotID, "*lock", 0
                                            PublicMessage BotID, "*scorereset", 0
                                            PublicMessage BotID, "*shipreset", 0
                                            PublicMessage BotID, "*arena GO! GO! GO!", 104
                                            .TimerCounter = 0
                                            If .GameType = ELIM_TYPE.JavElim Or .GameType = ELIM_TYPE.JavRace Then
                                                For I = 0 To MAX_PLAYERS
                                                    If .pList(I).SSName <> "" Then
                                                        If .pList(I).ShipType <> 1 And .pList(I).ShipType < 8 Then
                                                            PrivateMessage BotID, I, "*setship 2", 0
                                                        End If
                                                    End If
                                                Next
                                                .LockShip = 2
                                            ElseIf .GameType = ELIM_TYPE.WBElim Or .GameType = ELIM_TYPE.WBRace Then
                                                For I = 0 To MAX_PLAYERS
                                                    If .pList(I).SSName <> "" Then
                                                        If .pList(I).ShipType <> 0 And .pList(I).ShipType < 8 Then
                                                            PrivateMessage BotID, I, "*setship 1", 0
                                                        End If
                                                    End If
                                                Next
                                                .LockShip = 1
                                            ElseIf .GameType = ELIM_TYPE.GolfElim Then
                                                For I = 0 To MAX_PLAYERS
                                                    If .pList(I).SSName <> "" And .pList(I).ShipType < 8 Then
                                                        .pList(I).GamePoints = 1
                                                    Else
                                                        .pList(I).GamePoints = 0
                                                    End If
                                                Next
                                            End If
                                            If .GameType <> ELIM_TYPE.TeamElim Then
                                                SeparateTeams BotID
                                            Else
                                                MergeTeams BotID
                                            End If
                                            .Bot_Status = STARTED
                                        Else
                                            PublicMessage BotID, "*arena Not enough players. Elim will start when 2 players enter", 1
                                            .TimerCounter = 0
                                            .Bot_Status = CHECK
                                        End If
                                    End If

                            End Select

                        Case BOT_FLAVORS.CONQUER_REF
                            Select Case .Bot_Status
                                Case GAME_STATUS.CHECK
                                    'Enough players?
                                    If CheckPlayerCount(BotID, 4, False) = True Then
                                        If Not IsPublicArena(.ArenaName) Then PublicMessage BotID, "*zone Conquer starting. Type ?go " + .ArenaName + " to play!", 0
                                        PublicMessage BotID, "*arena Get ready; Conquer will start in 30 seconds", 2
                                        .Bot_Status = WAIT
                                        .TimerCounter = 0
                                    End If

                                Case GAME_STATUS.WAIT
                                    'Wait 10 seconds and check if there are enuf ppl again
                                    .TimerCounter = .TimerCounter + 1
                                    If .TimerCounter >= 30 Then
                                        If CheckPlayerCount(BotID, 4, False) = True Then
                                            SetupConquer BotID
                                            PublicMessage BotID, "*arena You have been gifted with the ability to enslave your fellow subspacians.", 0
                                            PublicMessage BotID, "*arena Who will be Supreme Ruler of the Universe?", 0
                                            PublicMessage BotID, "*arena Conquer!", 104
                                            PublicMessage BotID, "*lock", 0
                                            PublicMessage BotID, "*shipreset", 0
                                            .Bot_Status = STARTED
                                        Else
                                            PublicMessage BotID, "*arena Not enough players. Conquer will start when 4 players enter", 1
                                            .Bot_Status = CHECK
                                        End If
                                    End If

                                Case GAME_STATUS.STARTED
                                    'All checking is done on-demand.
                            End Select

                        Case BOT_FLAVORS.SARUNOKAMI_REF
                            .TimerCounter = .TimerCounter + 1
                            If .TimerCounter >= .TimerMax Then
                                .TimerCounter = 0
                                FiddleWithSettings BotID
                            End If

                        Case BOT_FLAVORS.BOUNTYGAME_REF
                            If .BountyID = -1 Then NewRabbit BotID, False

                        Case BOT_FLAVORS.ZOMBIES_REF
                            Select Case .Bot_Status
                                Case GAME_STATUS.CHECK
                                    'Enough players?
                                    If CheckPlayerCount(BotID, 3, False) = True Then
                                        If CheckPlayerCount(BotID, 1, True) = True Then
                                            .Bot_Status = WAIT
                                        End If
                                    End If

                                Case GAME_STATUS.PAUSE
                                    'Wait for 10 seconds if there are enuf players
                                    .TimerCounter = .TimerCounter + 1
                                    If .TimerCounter >= 20 Then
                                        If CheckPlayerCount(BotID, 3, False) = True Then
                                            If CheckPlayerCount(BotID, 1, True) = True Then
                                                AddGamePlayers BotID, True
                                                PublicMessage BotID, "*arena GO! GO! GO!", 104
                                                PublicMessage BotID, "*shipreset", 0
                                                .Bot_Status = STARTED
                                            Else
                                                PublicMessage BotID, "*arena One player must become a zombie on freq 1", 0
                                                .Bot_Status = CHECK
                                            End If
                                        Else
                                            PublicMessage BotID, "*arena Not enough players. Zombies will start when 3 players enter", 1
                                            .Bot_Status = CHECK
                                        End If
                                    End If

                                Case GAME_STATUS.STARTED
                                    'Check for GAME OVER
                                    If TotalItems(BotID) = 1 Then
                                        PublicMessage BotID, "*arena GAME OVER. Winner: " + SharedList(BotID, 1), 103
                                        .Bot_Status = WAIT
                                        For I = 0 To MAX_PLAYERS
                                            If .pList(I).SSName <> "" And .pList(I).Frequency = 1 And .pList(I).ShipType < 8 Then PrivateMessage BotID, I, "*setfreq 0", 0
                                        Next
                                    ElseIf TotalItems(BotID) = 0 Then
                                        PublicMessage BotID, "*arena GAME OVER. No winner", 103
                                        .Bot_Status = WAIT
                                        For I = 0 To MAX_PLAYERS
                                            If .pList(I).SSName <> "" And .pList(I).Frequency = 1 And .pList(I).ShipType < 8 Then PrivateMessage BotID, I, "*setfreq 0", 0
                                        Next
                                    End If

                                Case GAME_STATUS.WAIT
                                    'Wait for someone to become a zombie
                                    If CheckPlayerCount(BotID, 1, True) = True Then
                                        If CheckPlayerCount(BotID, 3, False) = True Then
                                            If Not IsPublicArena(.ArenaName) Then
                                                Select Case Int(Rnd * 4)
                                                    Case 0: PublicMessage BotID, "*zone Zombies starting. Type ?go " + .ArenaName + " to play!", 0
                                                    Case 1: PublicMessage BotID, "*zone ...and then there are Zombies. Type ?go " + .ArenaName + " to play!", 0
                                                    Case 2: PublicMessage BotID, "*zone Straying SubSpacians have awakened the Zombie Horde! Type ?go " + .ArenaName + " to save the human race!", 0
                                                    Case 3: PublicMessage BotID, "*zone Hi! I'm a 21-year-old blonde and I LOVE Zombies. Type ?go " + .ArenaName + " to play!", 0
                                                End Select
                                            End If
                                            PublicMessage BotID, "*arena Get ready; Zombies will start in 20 seconds.", 2
                                            .TimerCounter = 0
                                            .Bot_Status = PAUSE
                                        Else
                                            PublicMessage BotID, "*arena Not enough players. Zombies will start when 3 players enter", 1
                                            .Bot_Status = CHECK
                                        End If
                                    Else
                                        PublicMessage BotID, "*arena One player must become a zombie on freq 1", 0
                                        .Bot_Status = CHECK
                                    End If

                            End Select

                    End Select
                End If
            End If
        End With
    Next

Exit Sub
FlyPaper:
    AddDebug BotID, "Error detected in Periodic.Timer(): " + Err.Description, RED
    Resume Next
End Sub
